
import threading
# inspire de http://www.xavierdupre.fr/app/teachpyx/helpsphinx/c_parallelisation/thread.html#premier-thread
class Ping(threading.Thread):

    def __init__(self,name,semaphore1,semaphore2):
        threading.Thread.__init__(self)  # ne pas oublier cette ligne
        # (appel au constructeur de la classe mère)
        self.nom=name # self.name exite deja
        self.s1 = semaphore1
        self.s2 = semaphore2

    def run(self):
        for i in range (10):
            self.s1.acquire()
            print('Ping ',self.nom)
            self.s2.release()


class Pong(threading.Thread):

    def __init__(self, name, semaphore1, semaphore2):
        threading.Thread.__init__(self)  # ne pas oublier cette ligne
        # (appel au constructeur de la classe mère)
        self.nom = name  # self.name exite deja
        self.s1 = semaphore1
        self.s2 = semaphore2

    def run(self):
        for i in range(10):
            self.s1.acquire()
            print('Pong ', self.nom)
            self.s2.release()

def test():
    s1= threading.Semaphore(1)
    s2=threading.Semaphore(0)
    ping=Ping('ppp',s1,s2)
    pong = Pong('gg', s2, s1)
    ping.start()
    pong.start()

