# Documentation for the examples
*V Chevrier Dec 21*

## What to know
In python, use of **requests** package that enables call to web service (as html addresses do)
and use of **flask** package for web services.

## Examples Client side
### File appli1.py
Simple call to a distant web service : ask for weather in Nancy
see https://openweathermap.org/current#geo for more information



#### Questions

- Explain why we need to write ***print(answer.text)***
- what means the string output format ?
#### Exercise:

        1. Change response format to XML, the language as French
        2. learn how to ask for weather forecast (with free version)
        3. What happens if you type the following as address in your favorite web browser ?
            https://api.openweathermap.org/data/2.5/weather?lat=35&lon=139&appid=a2cabf37326f4cf77d2948c17c62705a
        4. Explain how to pass parameters to a web service

#### API reference
[https://openweathermap.org/api](https://openweathermap.org/price#weather)
have a look on it to learn what is **possible** and how

1. all requests need an id
2. there is a limit on the number of requests each day

## Examples: learn how to define services (and how to call them)

### A) exemple1 (and askex1)
basic service (just returns a string) and code for requests

### B) argument.py / askarg.py
A server to illustrate the use of arguments.

Services :
- service0 
    Shows how to build a simple service that
    - gets the parameters and their values
    - returns them as a list of couple ou value
    
    The returned values are as text format.

- exemple3 
    How to get  the value of a parameter
        
        Note that the parameter are in Json format 
        What is the type of the values we get ??
        
 - exemple 4 et exemple5 shows how to get typed values
 
### C) service1.py/askservice1.py
Simple service to show that returned value can change over time
The returned values are as **text** format.


### C') service1j.py/askservice1j.py
Simple service to show that returned value can change over time.
The returned values are as **json** format.

In askservice1 client
    - How is managed the json format?
    - Can you see an advantage to use it?

### service3.py
Use of global variables

##More interesting 
### The shutdown problem
When the server is running it uses a givent port on the machine and forbids another server to be run.

According to your programmig environment, it can be very difficult to shutdown/kill the server.

The file ***servershutdown.py*** shows how to integrate a shutdown service in the server.

### Non local server

serverNonLocal.py illustates how to have a non local server

Shows how to build a server with several services

See how the root return results as html
